#include "Globals.h"
#include <assert.h>
#include <iostream>
#include <map>
#include <cstdio>

using namespace std;


namespace aunfold
{



  static IDTYPE lastUsedID = 1;

  /** Create a new unique ID for vertices, edges, transformation rules etc */
  IDTYPE createNewID(void)
  {
    lastUsedID++;
    /** detect overflow*/
    assert(0 < lastUsedID);
    return lastUsedID;
  }

  void IDTYPE2xmlID(IDTYPE id, char *ch)
  {
    sprintf(ch,"_%i",id);
  }
  

  
  ostream& operator<<(ostream& os, std::map<IDTYPE,IDTYPE>& m)
  {
    for(map<IDTYPE,IDTYPE>::iterator i = m.begin(); i!=m.end(); i++)
      os << (*i).first << "->" << (*i).second << "  ";
    return os;
  }
  
  bool quiet (false);
  bool debug(false);
  bool trace(false);
  bool ncov(false);
  bool nfold(false);
	bool red(true);
	bool mapping(true);
	long depth(0);
	long unfdepth(-1);
	long maxstep(-1);
        long timeout(MAXLONG);
  
}
