#ifndef GLOBALS_H
#define GLOBALS_H

#include <iostream>
#include <map>

namespace aunfold
{
  

/** Type definition for IDs of vertices, edges etc. Change to __int64 if necessary.
    * Make shure operator< is defined for IDTYPE. */
  typedef unsigned IDTYPE;

  typedef enum VERTEDGE
  {
    VERTICE = 0,
    EDGE
  } VERTEDGE;
 
  IDTYPE createNewID(void);

  /** convert an IDTYPE value to an XML ID */
  void IDTYPE2xmlID(IDTYPE id, char *ch);
  
  // to print maps:
  std::ostream& operator<<(std::ostream& os, std::map<IDTYPE,IDTYPE>& m);

 #define MAXLONG ((long)0x7fffffff)
  
	extern bool quiet;
  extern bool debug;
  extern bool trace;
  extern bool ncov;
  extern bool nfold;
  extern bool red;
  extern bool mapping;
  extern long depth;
  extern long unfdepth;
  extern long maxstep;
  extern long timeout;
  
  
}

#endif
