/* Content:
   - aunfold.TransformationSystem
*/

#ifndef TRANSFORMATIONSYSTEM
#define TRANSFORMATIONSYSTEM

#include <map>
#include <iostream>
#include "TransformationRule.h"
#include "Globals.h"

namespace aunfold
{

  /** Representation of a Graph Grammar */


  class GraphGrammar
  {
  public:
    GraphGrammar();
    GraphGrammar(Hypergraph startgraph);
    GraphGrammar(const GraphGrammar& t);

    IDTYPE addRule(TransformationRule rule);
    TransformationRule& getRule(IDTYPE id);
    std::map<IDTYPE,TransformationRule> &getRules();
    Hypergraph& getStartGraph();
    friend std::ostream& operator<<(std::ostream& os, GraphGrammar& gg);


  private:

    std::map<IDTYPE,TransformationRule> rules;
    Hypergraph startgraph;
  };
}

#endif
