//#include "Hypergraph.h"
//#include TransformationiRule.h"




#include "Globals.h"
#include "PTNet.h"
#include "GraphGrammar.h"
#include "GTXLReader.h"
#include "Petrigraph.h"
#include "aunfold.h"

#include <map>
#include <set>
#include <list>
#include <iostream>

using namespace aunfold;
using namespace std;
/*
class PrintMatchHandler : public MatchHandler
{
public:
  bool useThisMatch(std::map<IDTYPE,IDTYPE> match);
};

bool PrintMatchHandler::useThisMatch(map<IDTYPE,IDTYPE> match)
{
  cout << "Matching found: \n";
  for(map<IDTYPE,IDTYPE>::iterator i = match.begin();
      i!=match.end();
      i++)
    cout << (*i).first << " -> " << (*i).second << "\n";
  cout << "\n\n";
  return false;
}

*/


int main(int argc, char**argv)
{

  GTXLReader reader("../dphil.xml");
  GraphGrammar g = reader.read();
  cout << g << "\n";
  Petrigraph pg = approximatedUnfolding(g);
  return 0;
  
  
  
  /* Test coverability graph set<IDTYPE> places;
  IDTYPE s1 = createNewID();
  IDTYPE s2 = createNewID();
  IDTYPE s3 = createNewID();
  places.insert(s1);
  places.insert(s2);
  places.insert(s3);

  // transition a:
  set<IDTYPE> a_preset;
  a_preset.insert(s1);
  set<IDTYPE> a_postset;
  a_postset.insert(s2);
  map<IDTYPE,unsigned> a_preweight;
  a_preweight.insert(pair<IDTYPE,unsigned>(s1,1));
  map<IDTYPE,unsigned> a_postweight;
  a_postweight.insert(pair<IDTYPE,unsigned>(s2,1));
  IDTYPE a_rule = createNewID();
  PTNetTransition a(a_preset,a_postset,a_preweight,a_postweight,a_rule);

  // transition b:
  set<IDTYPE> b_preset;
  b_preset.insert(s1);
  set<IDTYPE> b_postset;
  b_postset.insert(s3);
  map<IDTYPE,unsigned> b_preweight;
  b_preweight.insert(pair<IDTYPE,unsigned>(s1,1));
  map<IDTYPE,unsigned> b_postweight;
  b_postweight.insert(pair<IDTYPE,unsigned>(s3,1));
  IDTYPE b_rule = createNewID();
  PTNetTransition b(b_preset,b_postset,b_preweight,b_postweight,b_rule);
  
  // transition c
  set<IDTYPE> c_preset;
  c_preset.insert(s2);
  set<IDTYPE> c_postset;
  c_postset.insert(s2);
  c_postset.insert(s3);
  map<IDTYPE,unsigned> c_preweight;
  c_preweight.insert(pair<IDTYPE,unsigned>(s2,1));
  map<IDTYPE,unsigned> c_postweight;
  c_postweight.insert(pair<IDTYPE,unsigned>(s2,1));
  c_postweight.insert(pair<IDTYPE,unsigned>(s3,1));
  IDTYPE c_rule = createNewID();
  PTNetTransition c(c_preset,c_postset,c_preweight,c_postweight,c_rule);

  // transition d:
  set<IDTYPE> d_preset;
  d_preset.insert(s3);
  set<IDTYPE> d_postset;
  d_postset.insert(s2);
  map<IDTYPE,unsigned> d_preweight;
  d_preweight.insert(pair<IDTYPE,unsigned>(s3,1));
  map<IDTYPE,unsigned> d_postweight;
  d_postweight.insert(pair<IDTYPE,unsigned>(s2,1));
  IDTYPE d_rule = createNewID();
  PTNetTransition d(d_preset,d_postset,d_preweight,d_postweight,d_rule);

  // list of transitions:
  list<PTNetTransition> transitions;
  transitions.push_back(a);
  transitions.push_back(b);
  transitions.push_back(c);
  transitions.push_back(d);

  PTMarking initial_marking;
  initial_marking.insert(pair<IDTYPE,unsigned>(s1,1));
  initial_marking.insert(pair<IDTYPE,unsigned>(s2,0));
  initial_marking.insert(pair<IDTYPE,unsigned>(s3,0));

  PTNet ptnet(places,transitions,initial_marking);

  cout << "s1 <N s2? " << ptnet.inCausalityRelation(s1,s2) << "\n";
  cout << "s2 <N s1? " << ptnet.inCausalityRelation(s2,s1) << "\n";
  cout << "s1 <N a? " << ptnet.inCausalityRelation(s1,a.getID()) << "\n";
  cout << "c <N d? " << ptnet.inCausalityRelation(c.getID(),d.getID()) << "\n";
  cout << "d <N c? " << ptnet.inCausalityRelation(d.getID(),c.getID()) << "\n";
  cout << "d <N d? " << ptnet.inCausalityRelation(d.getID(),d.getID()) << "\n";
  cout << "b <N b? " << ptnet.inCausalityRelation(b.getID(),b.getID()) << "\n";
  cout << "s1 <N d? " << ptnet.inCausalityRelation(s1,d.getID()) << "\n";
  

  
  CovGraph cg(ptnet.getCoverabilityGraph());
  cg.print();
  
  
  
  */
  


  
  /* Test Hypergraph matching:
  Hypergraph g;
  IDTYPE v1 = g.addVertex();
  IDTYPE v2 = g.addVertex();
  IDTYPE v3 = g.addVertex();
  IDTYPE v4 = g.addVertex();
  IDTYPE v5 = g.addVertex();
  
  list<IDTYPE> l;
  l.push_back(v1); l.push_back(v2);
  IDTYPE e1 = g.addEdge(l,1234);

  l.clear();
  l.push_back(v2); l.push_back(v3);
  IDTYPE e2 = g.addEdge(l,1234);

  l.clear();
  l.push_back(v3); l.push_back(v4);
  IDTYPE e3 = g.addEdge(l,1234);

  l.clear();
  l.push_back(v4); l.push_back(v5);
  IDTYPE e4 = g.addEdge(l,1234);

  l.clear();
  l.push_back(v5); l.push_back(v1);
  IDTYPE e5 = g.addEdge(l,1234);

  l.clear();
  l.push_back(v3); l.push_back(v1);
  IDTYPE e51 = g.addEdge(l,1234);

  l.clear();
  l.push_back(v1); l.push_back(v4);
  IDTYPE e52 = g.addEdge(l,1234);
  
  
  

  cout << g << "\n";
  

  Hypergraph h;
  IDTYPE v6 = h.addVertex();
  IDTYPE v7 = h.addVertex();
  IDTYPE v8 = h.addVertex();
  
  l.clear();
  l.push_back(v6); l.push_back(v7);
  IDTYPE e6 = h.addEdge(l,1234);
  l.clear();
  l.push_back(v7);l.push_back(v8);
  IDTYPE e7 = h.addEdge(l,1234);
  l.clear();
  l.push_back(v8); l.push_back(v6);
  IDTYPE e8 = h.addEdge(l,1234);
  
  
  
  
  cout << h << "\n\n";

  PrintMatchHandler pmh;
  g.findMatching(h,pmh);
  end test hypergraph matching */

  


  return 0;
}

