#include "TransitionSet.h"
#include <sstream>

TransitionSet::TransitionSet() { count = 0;} // constructor

// is this set empty?
bool TransitionSet::isEmpty() { return transitionSet.empty(); }

// provide access to a transition via its ID
Transition* TransitionSet::getTransition(int id) { return transitionSet[id]; }

/* add a transition to this set,
   each transition gets a unique ID */
int TransitionSet::add(Transition* in) {
  count++;
  transitionSet[count] = in;
  return count;
}


  // return string-representation of this set
string TransitionSet::asString(stringMap* placeNames,stringMap* transNames) {
  ostringstream os;
  for (i=transitionSet.begin(); i!=transitionSet.end(); ++i) { 
    os << "Transition " 
       << transNames->getString(i->first)
       << ": " 
       << (i->second)->asString(placeNames); 
  }   
  return os.str();
}

// iterator methods, pointing an iterator to begin/end of this set
TransitionSet::iterator TransitionSet::begin() { return transitionSet.begin(); }
TransitionSet::iterator TransitionSet::end() { return transitionSet.end(); }

// provide access to transitions via iterator
Transition* TransitionSet::getTransition(TransitionSet::iterator iter) { 
  return iter->second; 
}

// provide access to transitions IDs via iterator
int TransitionSet::getID(TransitionSet::iterator iter) { 
  return iter->first; 
}

// in all transitions given places will be united to the first one
void TransitionSet::unionPlaces(int place1, int place2) {
  for (i=transitionSet.begin(); i!=transitionSet.end(); ++i) { 
    i->second->unionPlaces(place1,place2);
  }
}
